#include "CPULoadIcon.h"
#include <stdlib.h>
#include <View.h>

       


extern "C" _EXPORT BView *instantiate_deskbar_item(void)
{
	puts("Instanciating CPULoad TrayView...");
	return (new TrayView);
}


long removeFromDeskbar(void *)
{	
	BDeskbar db;
	printf("Removing CPULoad from BDeskbar\n");
	if (db.RemoveItem(APP_NAME) != B_OK)
		printf("Unable to remove CPULoad from BDeskbar\n");
		
	return 0;
}

//**************************************************

ConfigMenu::ConfigMenu(TrayView *tv, bool useMag)
	:BPopUpMenu("config_popup", false, false){

	BMenu *tmpm;
	BMenuItem *tmpi;
	BMessage *msg;
	bigtime_t delay;
	
	CPULoadSettings *s = tv->Settings();
	
	SetFont(be_plain_font);

//	BMenuItem *active = new BMenuItem("Active", new BMessage(MSG_TOOGLE_ACTIVE));
//	active->SetMarked(s->Active());

	tmpm = new BMenu("Show scale");
	tmpm->SetFont(be_plain_font);

	msg = new BMessage(MSG_SET_SCALE);
	msg->AddInt32(CL_SHOW_SCALE, Scale_No);
	tmpi = new BMenuItem("No", msg);
	tmpi->SetMarked(s->ShowScale() == Scale_No);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_SCALE);
	msg->AddInt32(CL_SHOW_SCALE, Scale_Under);
	tmpi = new BMenuItem("Under graph", msg);
	tmpi->SetMarked(s->ShowScale() == Scale_Under);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_SCALE);
	msg->AddInt32(CL_SHOW_SCALE, Scale_Over);
	tmpi = new BMenuItem("Over graph", msg);
	tmpi->SetMarked(s->ShowScale() == Scale_Over);
	tmpm->AddItem(tmpi);

	tmpm->SetTargetForItems(tv);
	BMenuItem *scale = new BMenuItem(tmpm);
	

	
	tmpm = new BMenu("Graph type");
	tmpm->SetFont(be_plain_font);

	msg = new BMessage(MSG_SET_GRTYPE);
	msg->AddInt32(CL_GRAPH_TYPE, Graph_Dots);
	tmpi = new BMenuItem("Dots", msg);
	tmpi->SetMarked(s->GraphType() == Graph_Dots);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_GRTYPE);
	msg->AddInt32(CL_GRAPH_TYPE, Graph_Lines);
	tmpi = new BMenuItem("Lines", msg);
	tmpi->SetMarked(s->GraphType() == Graph_Lines);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_GRTYPE);
	msg->AddInt32(CL_GRAPH_TYPE, Graph_Filled);
	tmpi = new BMenuItem("Filled", msg);
	tmpi->SetMarked(s->GraphType() == Graph_Filled);
	tmpm->AddItem(tmpi);

	tmpm->SetTargetForItems(tv);
	BMenuItem *graphtypem = new BMenuItem(tmpm);
	


	tmpm = new BMenu("Delay");
	tmpm->SetFont(be_plain_font);

	msg = new BMessage(MSG_SET_DELAY);
	msg->AddInt64(CL_DELAY, 100000LL);
	tmpi = new BMenuItem("0.1 s", msg);
	tmpi->SetMarked(s->Delay() == 100000LL);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_DELAY);
	msg->AddInt64(CL_DELAY, 200000LL);
	tmpi = new BMenuItem("0.2 s", msg);
	tmpi->SetMarked(s->Delay() == 200000LL);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_DELAY);
	msg->AddInt64(CL_DELAY, 500000LL);
	tmpi = new BMenuItem("0.5 s", msg);
	tmpi->SetMarked(s->Delay() == 500000LL);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_DELAY);
	msg->AddInt64(CL_DELAY, 1000000LL);
	tmpi = new BMenuItem("1 s", msg);
	tmpi->SetMarked(s->Delay() == 1000000LL);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_DELAY);
	msg->AddInt64(CL_DELAY, 2000000LL);
	tmpi = new BMenuItem("2 s", msg);
	tmpi->SetMarked(s->Delay() == 2000000LL);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_DELAY);
	msg->AddInt64(CL_DELAY, 3000000LL);
	tmpi = new BMenuItem("3 s", msg);
	tmpi->SetMarked(s->Delay() == 3000000LL);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_DELAY);
	msg->AddInt64(CL_DELAY, 4000000LL);
	tmpi = new BMenuItem("4 s", msg);
	tmpi->SetMarked(s->Delay() == 4000000LL);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_DELAY);
	msg->AddInt64(CL_DELAY, 5000000LL);
	tmpi = new BMenuItem("5 s", msg);
	tmpi->SetMarked(s->Delay() == 5000000LL);
	tmpm->AddItem(tmpi);

	tmpm->SetTargetForItems(tv);
	BMenuItem *delaym = new BMenuItem(tmpm);
	

	AddItem(scale);
	AddItem(graphtypem);
	AddItem(delaym);


	AddSeparatorItem();
//	AddItem(new BMenuItem("Settings...", new BMessage(OPEN_SETTINGS)));
	
	AddItem(new BMenuItem("About "APP_NAME, new BMessage(B_ABOUT_REQUESTED)));
	AddItem(new BMenuItem("Remove from tray", new BMessage(REMOVE_FROM_TRAY)));
		
	SetTargetForItems(tv);
	SetAsyncAutoDestruct(true);
}

ConfigMenu::~ConfigMenu() {}

//************************************************

TrayView::TrayView()
	:BView(BRect(0, 0, B_MINI_ICON, B_MINI_ICON -1), APP_NAME, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW){
	_init(); 	//Initialization common to both constructors
}

//Rehydratable constructor
TrayView::TrayView(BMessage *mdArchive):BView(mdArchive){
	_init();		//As above
}

void TrayView::GetPreferredSize(float *w, float *h)
{
	*w = B_MINI_ICON;
	*h = B_MINI_ICON - 1;
}

void TrayView::_init()
{
	status_t err;
	_msgrunner = NULL;
	_settings = new CPULoadSettings;
	_appPath = _settings->AppPath();
	
	for (loadidx=0; loadidx < GRAPH_WIDTH; loadidx++)
		load_avg[loadidx] = 0;
	loadidx=0;
	
	SetDrawingMode(B_OP_ALPHA);
	SetFlags(Flags() | B_WILL_DRAW);
}

TrayView::~TrayView(){
	if (_msgrunner) delete _msgrunner;
	if (_settings) delete _settings;
	return;
}

//Dehydrate into a message (called by the DeskBar)
status_t TrayView::Archive(BMessage *data, bool deep = true) const {
	status_t error=BView::Archive(data, deep);
	data->AddString("add_on", APP_SIG);
	data->AddRef("_appPath", &_appPath);

	return B_NO_ERROR;
}

//Rehydrate the View from a given message (called by the DeskBar)
TrayView *TrayView::Instantiate(BMessage *data) {

	if (!validate_instantiation(data, "TrayView"))
	{
		return NULL;
	}
	
	return (new TrayView(data));
}

void TrayView::AttachedToWindow() {
	if(Parent())
		SetViewColor(Parent()->ViewColor());
	BMessenger messenger(this);
	_msgrunner = new BMessageRunner(messenger, new BMessage(MSG_UPDATE), _settings->Delay(), -1);
}

void TrayView::Draw(BRect updaterect) {
	BRect bnds(Bounds());
	int idx;
	
	if (Parent()) SetHighColor(Parent()->ViewColor());
	else SetHighColor(189, 186, 189, 255);
	FillRect(bnds);

	BPoint u, d, p; // Up, Down, Previous (up)

	if (_settings->ShowScale() == Scale_Under) {
		SetHighColor(255, 255, 255, 255);
		d.x = bnds.left;
		d.y = (bnds.bottom - bnds.top) / 2;
		MovePenTo(d);
		for (int i = 0; i < GRAPH_WIDTH; i+=2) {
			StrokeLine(d);
			d.x+=2.0f;
			MovePenTo(d);
		}
	}


	SetHighColor(_settings->GraphColor());
	d.x = bnds.left;
	d.y = bnds.bottom;
	p.x = u.x = bnds.left;

	idx = loadidx;
	
	p.y = GRAPH_HEIGHT - load_avg[(idx)%GRAPH_WIDTH];
	
	for (int x = 0; x < GRAPH_WIDTH; x++) {
		u.y = GRAPH_HEIGHT - load_avg[(idx+x)%GRAPH_WIDTH];
		switch (_settings->GraphType()) {
		case Graph_Dots:
			StrokeLine(u, u);
			break;
		case Graph_Lines:
			StrokeLine(p, u);
			break;
		case Graph_Filled:
		default:
			StrokeLine(u, d);
			break;
		}
		p = u;
		d.x++;
		u.x++;
	}

	if (_settings->ShowScale() == Scale_Over) {
		SetHighColor(255, 255, 255, 255);
		d.x = bnds.left;
		d.y = (bnds.bottom - bnds.top) / 2;
		MovePenTo(d);
		for (int i = 0; i < GRAPH_WIDTH; i+=2) {
			StrokeLine(d);
			d.x+=2.0f;
			MovePenTo(d);
		}
	}
}

void TrayView::MouseDown(BPoint where) {
	BWindow *window = Window();	/*To handle the MouseDown message*/
	if (!window)	/*Check for proper instantiation*/
		return;
		
	BMessage *mouseMsg = window->CurrentMessage();
	if (!mouseMsg)	/*Check for existence*/
		return;
		
	if (mouseMsg->what == B_MOUSE_DOWN) {
		/*Variables for storing the button pressed / modifying key*/
		uint32 	buttons = 0;
		uint32  modifiers = 0;
		
		/*Get the button pressed*/
		mouseMsg->FindInt32("buttons", (int32 *) &buttons);
		/*Get modifier key (if any)*/
		mouseMsg->FindInt32("modifiers", (int32 *) &modifiers);
		
		/*Now perform action*/
		switch(buttons) {
			case B_PRIMARY_MOUSE_BUTTON:
				_settings->SetGraphType((_settings->GraphType()+1)%3); // cycle through graph types :-)
				break;
			case B_SECONDARY_MOUSE_BUTTON: 
			{
				ConvertToScreen(&where);

				//menu will delete itself (see constructor of ConfigMenu),
				//so all we're concerned about is calling Go() asynchronously
				ConfigMenu *menu = new ConfigMenu(this, false);
				menu->Go(where, true, true, ConvertToScreen(Bounds()), true); 

				break;
			}
		}
	}
}	


void TrayView::Update(void)
{
	// from Pulse application: PulseView.cpp
	// Calculate work done since last call to Update() for each CPU
	system_info sys_info;
	bigtime_t now;
	double loadavg = 0;

	get_system_info(&sys_info);
	now = system_time();

	for (int x = 0; x < sys_info.cpu_count; x++) {
		double cpu_time = (double)(sys_info.cpu_infos[x].active_time - prev_active[x]) / (now - prev_time);
		prev_active[x] = sys_info.cpu_infos[x].active_time;
		if (cpu_time < 0) cpu_time = 0;
		if (cpu_time > 1) cpu_time = 1;
		cpu_times[x] = cpu_time;
	}
	prev_time = now;

	for (int x = 0; x < sys_info.cpu_count; x++)
		loadavg += cpu_times[x];
	load_avg[loadidx] = (char)((GRAPH_HEIGHT * loadavg) / (double)sys_info.cpu_count);
	loadidx = (loadidx + 1) % GRAPH_WIDTH;

	return;
}

void TrayView::MessageReceived(BMessage* message)
{

	BAlert *alert;
	bigtime_t delay;
	int32 grtype;
	int32 showscale;
	
	// from Tracker: tracker/DeskWindow.cpp
	if (message->WasDropped()) {
		const rgb_color *color;
		int32 size;
		
		// handle "roColour"-style color drops
		if (message->FindData("RGBColor", 'RGBC', (const void **)&color, &size) == B_OK) {
			_settings->SetGraphColor(*color);
			return;
		}
	}
	
	switch(message->what)
	{		
		case MSG_SET_SCALE:
			showscale = Scale_Under;
			message->FindInt32(CL_SHOW_SCALE, &showscale);
			_settings->SetShowScale(showscale);
			break;
		case MSG_SET_GRTYPE:
			grtype = Graph_Filled;
			message->FindInt32(CL_GRAPH_TYPE, &grtype);
			_settings->SetGraphType(grtype);
			break;
		case MSG_SET_DELAY:
		{
			BMessenger messenger(this);

			puts("set delay");
			delay = DEFAULT_DELAY;
			message->FindInt64(CL_DELAY, &delay);
			_settings->SetDelay(delay);
			if (_msgrunner) delete _msgrunner;
			_msgrunner = new BMessageRunner(messenger, new BMessage(MSG_UPDATE), _settings->Delay(), -1);

			break;
		}
		case REMOVE_FROM_TRAY:
		{
			thread_id tid = spawn_thread(removeFromDeskbar, "RemoveFromDeskbar", B_NORMAL_PRIORITY, NULL);
			if (tid) resume_thread(tid);
		
			break;
		}
		case MSG_UPDATE:
			Update();
//			Draw(Bounds()); // Pulse does that...
			Invalidate();
			break;
		case B_ABOUT_REQUESTED:
			alert = new BAlert("about box", "CPULoad, (c) 2002, mmu_man\nInspired by a windows systray util called CPULOAD.EXE\n\nEnjoy :-)", "Ok", NULL, NULL,
                B_WIDTH_AS_USUAL, B_OFFSET_SPACING, B_INFO_ALERT);
	        alert->SetShortcut(0, B_ENTER);
    	    alert->Go(NULL);	// use the asynchronous version
			break;
		default:
			BView::MessageReceived(message);
	}
}

CPULoadSettings *TrayView::Settings() const
{
	return _settings;
}

