#ifndef COMMON_H
#define COMMON_H

#include <stdio.h>

#include <AppKit.h>
#include <InterfaceKit.h>
#include <String.h>
#include <StorageKit.h>


// R5.1 has a very helpful API...
#if (B_BEOS_VERSION == 0x0510)
#define USE_DANO_HACK
#endif

/***************************************************
	common.h
	Constants used by app
***************************************************/

// used to check the image to use to get the resources
#define APP_NAME "DBCpuLoad"
#define APP_SIG "application/x-vnd.mmu.DBCpuLoad" 
#define SETTINGS_FILE "x-vnd.mmu.CpuLoad_settings"

//names of data segments in settings file
//also used in messages

#define DEFAULT_DELAY 500000LL

// float: delay before raise
#define CL_DELAY "cl:delay"
// rgb_color
#define CL_COLOR "cl:color"

#define CL_SHOW_SCALE "cl:showscale"
enum {
	Scale_No,
	Scale_Under,
	Scale_Over
};
// type of drawing
#define CL_GRAPH_TYPE "cl:gtype"
enum {
	Graph_Dots,
	Graph_Lines,
	Graph_Filled
};

// messages

#define ADD_TO_TRAY 'zATT'
#define REMOVE_FROM_TRAY 'zRFT'

#define OPEN_SETTINGS 'zOPS'



#define MSG_UPDATE 'clUP'

#define MSG_SET_DELAY 'clSD'
#define MSG_SET_GRTYPE 'clGT'
#define MSG_SET_SCALE 'clSS'

#endif
